#ifndef CHIP_CLK_H
#define CHIP_CLK_H

#include "chip_std_defs.h"
#include "chip_clk_defs.h"
#include "chip_cfg_defs.h"

#define CHIP_CLK_HSE_EN  (CHIP_CLK_HSE_MODE != CHIP_CLK_EXTMODE_DIS)
#define CHIP_CLK_LSE_EN  (CHIP_CLK_LSE_MODE != CHIP_CLK_EXTMODE_DIS)

#if CHIP_CLK_HSE_EN
    #ifndef CHIP_CFG_CLK_HSE_FREQ
        #error HSE clock frequency is not specified
    #endif
    #define CHIP_CLK_HSE_FREQ       CHIP_CFG_CLK_HSE_FREQ
#else
    #define CHIP_CLK_HSE_FREQ       0
#endif


#if CHIP_CLK_PLL_EN
    #define CHIP_CLK_PLL_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_PLL_SRC)
    #if CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_CLK_PLL_SRC_FREQ    CHIP_CLK_HSI_FREQ
        #define CHIP_CLK_PLL_SRC_EN      CHIP_CLK_HSI_EN
    #elif CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_CLK_PLL_SRC_FREQ    CHIP_CLK_HSE_FREQ
        #define CHIP_CLK_PLL_SRC_EN      CHIP_CLK_HSE_EN
    #else
        #define CHIP_CLK_PLL_SRC_FREQ    0
        #define CHIP_CLK_PLL_SRC_EN      0
    #endif

    #define CHIP_CLK_PLL_IN_FREQ        (CHIP_CLK_PLL_SRC_FREQ / CHIP_CLK_PLL_PREDIV)
    #if CHIP_CLK_PLL_BYPASS
        #define CHIP_CLK_PLL_FREQ       CHIP_CLK_PLL_IN_FREQ
    #else
        #define CHIP_CLK_PLL_VCO_FREQ   (CHIP_CLK_PLL_IN_FREQ * CHIP_CLK_PLL_MUL)
        #define CHIP_CLK_PLL_FREQ       (CHIP_CLK_PLL_VCO_FREQ / CHIP_CLK_PLL_OUTDIV)
    #endif
#else
    #define CHIP_CLK_PLL_SRC_FREQ  0
    #define CHIP_CLK_PLL_IN_FREQ   0
    #define CHIP_CLK_PLL_VCO_FREQ  0
    #define CHIP_CLK_PLL_FREQ      0
#endif





#define CHIP_CLK_SYS_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_SYS_SRC)
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSI_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSE_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_PLL_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_PLL_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_PLL_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_LSE_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_LSI_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_LSI_EN
#else
    #define CHIP_CLK_SYS_FREQ 0
    #define CHIP_CLK_SYS_EN   0
#endif


#define CHIP_CLK_AHB_FREQ       (CHIP_CLK_SYS_FREQ / CHIP_CLK_AHB_DIV)
#define CHIP_CLK_APB1_FREQ      (CHIP_CLK_AHB_FREQ / CHIP_CLK_APB1_DIV) /* частота шины APB1 */
#define CHIP_CLK_APB2_FREQ      (CHIP_CLK_AHB_FREQ / CHIP_CLK_APB2_DIV) /* частота шины APB1 */

#define CHIP_CLK_HCLK_FREQ      CHIP_CLK_AHB_FREQ
#define CHIP_CLK_HCLK_EN        1

#define CHIP_CLK_SYSTICK_FREQ   CHIP_CLK_AHB_FREQ

#if CHIP_CLK_MCO_EN
    #define CHIP_CLK_MCO_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_MCO_SRC)
    #if CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ   CHIP_CLK_LSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN     CHIP_CLK_LSI_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_LSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_LSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_SYS_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_SYS_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSI_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_PLL_ID
        #define CHIP_CLK_MCO_SRC_FREQ (CHIP_CLK_PLL_FREQ/CHIP_CLK_MCO_PLL_DIV)
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_PLL_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_LSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_LSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_LSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_LSI_EN
    #else
        #define CHIP_CLK_MCO_SRC_FREQ 0
        #define CHIP_CLK_MCO_SRC_EN   0
    #endif
#endif


#define CHIP_CLK_LPUART1_SRC_ID         CHIP_CLK_ID_VAL(CHIP_CLK_LPUART1_SRC)
#if CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_APB1_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_APB1_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_APB1_EN
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_SYS_EN
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_HSI_EN
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_HSE_EN
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_LSI_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_LSI_EN
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_LPUART1_SRC_FREQ   CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_LPUART1_SRC_EN     CHIP_CLK_LSE_EN
#else
    #define CHIP_CLK_LPUART1_SRC_FREQ   0
    #define CHIP_CLK_LPUART1_SRC_EN     0
#endif

#if CHIP_DEV_LPUART_CNT >= 2
    #define CHIP_CLK_LPUART2_SRC_ID         CHIP_CLK_ID_VAL(CHIP_CLK_LPUART2_SRC)
    #if CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_APB1_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_APB1_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_APB1_EN
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_SYS_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_SYS_EN
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_HSI_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_HSI_EN
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_HSE_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_HSE_EN
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_LSI_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_LSI_EN
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_CLK_LPUART2_SRC_FREQ   CHIP_CLK_LSE_FREQ
        #define CHIP_CLK_LPUART2_SRC_EN     CHIP_CLK_LSE_EN
    #else
        #define CHIP_CLK_LPUART2_SRC_FREQ   0
        #define CHIP_CLK_LPUART2_SRC_EN     0
    #endif
#endif


#define CHIP_CLK_LPTIM_SRC_ID           CHIP_CLK_ID_VAL(CHIP_CLK_LPTIM_SRC)
#if CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_APB1_ID
    #define CHIP_CLK_LPTIM_SRC_FREQ     CHIP_CLK_APB1_FREQ
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_APB1_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_LPTIM_SRC_FREQ     CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_HSI_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_LPTIM_SRC_FREQ     CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_HSE_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_CLK_LPTIM_SRC_FREQ     CHIP_CLK_LSI_FREQ
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_LSI_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_LPTIM_SRC_FREQ     CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_LSE_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_COMP_ID
    /** @todo */
    #define CHIP_CLK_LPTIM_SRC_FREQ     -1
    #define CHIP_CLK_LPTIM_SRC_EN       CHIP_CLK_COMP_EN
#else
    #define CHIP_CLK_LPTIM_SRC_FREQ     0
    #define CHIP_CLK_LPTIM_SRC_EN       0
#endif

/* -------------------- ADC Freq ---------------------------------------------*/
#define CHIP_CLK_ADC_PLL_FREQ           (CHIP_CLK_ADC_PLL_DIV == 0 ? 0 : (CHIP_CLK_PLL_FREQ / CHIP_CLK_ADC_PLL_DIV))
#define CHIP_CLK_ADC_PLL_EN             (CHIP_CLK_PLL_EN  && (CHIP_CLK_ADC_PLL_DIV != 0))

#define CHIP_CLK_ADC_HCLK_FREQ          (CHIP_CLK_HCLK_FREQ / CHIP_CLK_ADC_HCLK_DIV)
#define CHIP_CLK_ADC_HCLK_EN            (CHIP_CLK_HCLK_EN)

#define CHIP_CLK_ADC_SRC_ID         CHIP_CLK_ID_VAL(CHIP_CLK_ADC_SRC)
#if CHIP_CLK_ADC_SRC_ID == CHIP_CLK_ADC_HCLK_ID
    #define CHIP_CLK_ADC_SRC_FREQ   CHIP_CLK_ADC_HCLK_FREQ
    #define CHIP_CLK_ADC_SRC_EN     CHIP_CLK_ADC_HCLK_EN
#elif CHIP_CLK_ADC_SRC_ID == CHIP_CLK_ADC_PLL_ID
    #define CHIP_CLK_ADC_SRC_FREQ   CHIP_CLK_ADC_PLL_FREQ
    #define CHIP_CLK_ADC_SRC_EN     CHIP_CLK_ADC_PLL_EN
#else
    #define CHIP_CLK_ADC_SRC_FREQ   0
    #define CHIP_CLK_ADC_SRC_EN     0
#endif

#define CHIP_CLK_ADC_FREQ       CHIP_CLK_ADC_SRC_FREQ


#define CHIP_CLK_ADC_1M_SRC_ID      CHIP_CLK_ID_VAL(CHIP_CLK_ADC_1M_SRC)
#if CHIP_CLK_ADC_1M_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_ADC_1M_SRC_FREQ   CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_ADC_1M_SRC_EN     CHIP_CLK_HSI_EN
#elif CHIP_CLK_ADC_1M_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_ADC_1M_SRC_FREQ   CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_ADC_1M_SRC_EN     CHIP_CLK_HSE_EN
#else
    #define CHIP_CLK_ADC_1M_SRC_FREQ   0
    #define CHIP_CLK_ADC_1M_SRC_EN     0
#endif
#define CHIP_CLK_ADC_1M_FREQ        (CHIP_CLK_ADC_1M_SRC_FREQ/CHIP_CLK_ADC_1M_DIV)
#define CHIP_CLK_ADC_1M_EN          CHIP_CLK_ADC_1M_SRC_EN


/* частота таймеров в 2 раза больше частоты шины APB, если только делитель ABP не равен 1 */
#if CHIP_CLK_APB1_DIV == 1
    #define CHIP_CLK_APB1_TIM_FREQ   CHIP_CLK_APB1_FREQ
#else
    #define CHIP_CLK_APB1_TIM_FREQ   (2*CHIP_CLK_APB1_FREQ)
#endif
#if CHIP_CLK_APB2_DIV == 1
    #define CHIP_CLK_APB2_TIM_FREQ   CHIP_CLK_APB2_FREQ
#else
    #define CHIP_CLK_APB2_TIM_FREQ   (2*CHIP_CLK_APB2_FREQ)
#endif

#define CHIP_CLK_TIM1_8_SRC_ID          CHIP_CLK_ID_VAL(CHIP_CFG_CLK_TIM1_8_SRC)
#if CHIP_CLK_TIM1_8_SRC_ID == CHIP_CLK_APB2_TIM_ID
    #define CHIP_CLK_TIM1_8_SRC_FREQ    CHIP_CLK_APB2_FREQ
    #define CHIP_CLK_TIM1_8_SRC_EN      CHIP_CLK_APB2_EN
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_TIM1_8_SRC_FREQ    CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_TIM1_8_SRC_EN      CHIP_CLK_SYS_EN
#else
    #define CHIP_CLK_TIM1_8_SRC_FREQ    0
    #define CHIP_CLK_TIM1_8_SRC_EN      0
#endif

#define CHIP_CLK_TIM1_FREQ              CHIP_CLK_TIM1_8_SRC_FREQ
#define CHIP_CLK_TIM3_FREQ              CHIP_CLK_APB1_TIM_FREQ
#if CHIP_DEV_SUPPORT_TIM4
#define CHIP_CLK_TIM4_FREQ              CHIP_CLK_APB1_TIM_FREQ
#endif
#define CHIP_CLK_TIM6_FREQ              CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM8_FREQ              CHIP_CLK_TIM1_8_SRC_FREQ
#define CHIP_CLK_LPTIM_FREQ             CHIP_CLK_LPTIM_SRC_FREQ

#define CHIP_CLK_CPU_FREQ               CHIP_CLK_AHB_FREQ
#define CHIP_CLK_FLASH_FREQ             CHIP_CLK_AHB_FREQ
#define CHIP_CLK_DMA_FREQ               CHIP_CLK_AHB_FREQ
#define CHIP_CLK_SRAM_FREQ              CHIP_CLK_AHB_FREQ
#define CHIP_CLK_HSQRT_FREQ             CHIP_CLK_AHB_FREQ
#define CHIP_CLK_CRC_FREQ               CHIP_CLK_AHB_FREQ
#define CHIP_CLK_HDIV_FREQ              CHIP_CLK_AHB_FREQ
#if CHIP_DEV_SUPPORT_RNG
#define CHIP_CLK_RNG_FREQ               CHIP_CLK_AHB_FREQ
#endif
#if CHIP_DEV_SUPPORT_SAC
#define CHIP_CLK_SAC_FREQ               CHIP_CLK_AHB_FREQ
#endif


#define CHIP_CLK_USART1_FREQ            CHIP_CLK_APB2_FREQ
#define CHIP_CLK_USART2_FREQ            CHIP_CLK_APB1_FREQ
#if CHIP_DEV_SUPPORT_UART5
#define CHIP_CLK_UART5_FREQ             CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_SUPPORT_UART6
#define CHIP_CLK_UART6_FREQ             CHIP_CLK_APB2_FREQ
#endif
#define CHIP_CLK_LPUART1_FREQ           CHIP_CLK_LPUART1_SRC_FREQ
#if CHIP_DEV_LPUART_CNT >= 2
#define CHIP_CLK_LPUART2_FREQ           CHIP_CLK_LPUART2_SRC_FREQ
#endif

#define CHIP_CLK_SPI1_FREQ              CHIP_CLK_APB2_FREQ
#define CHIP_CLK_SPI2_FREQ              CHIP_CLK_APB2_FREQ
#if CHIP_DEV_SPI_CNT >= 3
#define CHIP_CLK_SPI3_FREQ              CHIP_CLK_APB2_FREQ
#endif
#define CHIP_CLK_I2C1_FREQ              CHIP_CLK_APB1_FREQ
#define CHIP_CLK_I2C2_FREQ              CHIP_CLK_APB1_FREQ
#if CHIP_DEV_CAN_CNT >= 1
#define CHIP_CLK_CAN1_FREQ              CHIP_CLK_APB1_FREQ
#endif
#define CHIP_CLK_WWDG_FREQ              CHIP_CLK_APB1_FREQ
#define CHIP_CLK_COMP_FREQ              CHIP_CLK_APB1_FREQ
#define CHIP_CLK_OPA_FREQ               CHIP_CLK_APB1_FREQ
#if CHIP_DEV_SUPPORT_RNG
#define CHIP_CLK_TSC_FREQ               CHIP_CLK_APB1_FREQ
#endif
#define CHIP_CLK_BEEP1_FREQ             CHIP_CLK_APB1_FREQ
#if CHIP_DEV_BEEPER_CNT >= 2
#define CHIP_CLK_BEEP2_FREQ             CHIP_CLK_APB2_FREQ
#endif

#endif // CHIP_CLK_H
